module UnitSphere() { sphere(50); }
module UnitBox() { cube(100, true); }

module HullShape() {
	scale([55, 377, 21]) /*rotate([90, 0, 0])*/ UnitSphere();
}
module ShipHull() {
	difference() {
		HullShape();

		translate([0, 12400, 0]) scale([89, 55, 1]) UnitBox();
		translate([0, 12400, 300]) scale([89, 55, 1]) UnitBox();
		translate([0, 12400, -300]) scale([89, 55, 1]) UnitBox();

		translate([0, 3400, 600]) scale([89, 55, 1]) UnitBox();
		translate([0, 3400, -600]) scale([89, 55, 1]) UnitBox();
		translate([0, -3400, 600]) scale([89, 55, 1]) UnitBox();
		translate([0, -3400, -600]) scale([89, 55, 1]) UnitBox();
	

		translate([0, 37700/2, -300]) scale([89, 55, 1]) UnitBox();
		translate([0, -37700/2, 0]) scale([5, 13, 3]) UnitSphere();
	}
}
module ShipWindows() {
	difference() {
		scale(0.97) HullShape();
		translate([0, 37700/2, -300])
			scale([89.3, 55.3, 1.3])
				UnitBox();
		translate([0, -37700/2, 0])
			scale([5.3, 13.3, 3.3])
				UnitSphere();
	}
}

module GunTurret() {
	union() {
		difference() {
			scale([8, 8, 3]) UnitSphere();
			scale([10, 10, 0.25]) UnitBox();
			translate([0, 250, 100]) scale([3, 5, 2]) UnitBox();
		}

		cylinder(r = 250, h = 25, center = true);

		translate([0, 0, 80])
			rotate([-90, 0, 0])
				cylinder(h = 500, r = 40);
		translate([100, 0, 80])
			rotate([-90, 0, 0])
				cylinder(h = 500, r = 40);
		translate([-100, 0, 80])
			rotate([-90, 0, 0])
				cylinder(h = 500, r = 40);
	}
}

module Bonaventure() {
	color("silver") ShipHull();
	color("yellow", alpha=0.9) ShipWindows();

	// The hangars.
	color("silver") {
		scale([1.05, 1, 1]) intersection() {
			HullShape();
			scale([89, 55, 8]) UnitBox();
		}
		scale([1.05, 1, 1]) intersection() {
			HullShape();
			translate([0, 6300, 0]) scale([89, 55, 8]) UnitBox();
		}
		scale([1.05, 1, 1]) intersection() {
			HullShape();
			translate([0, -6300, 0]) scale([89, 55, 8]) UnitBox();
		}
	}

	// The gills.
	color("silver") {
		scale([1.05, 1, 1]) intersection() {
			HullShape();
			translate([0, 8900, 600]) scale([89, 2, 2]) UnitBox();
			
		}
		scale([1.05, 1, 1]) intersection() {
			HullShape();
			translate([0, 8500, 600]) scale([89, 2, 2]) UnitBox();
			
		}
		scale([1.05, 1, 1]) intersection() {
			HullShape();
			translate([0, 8100, 600]) scale([89, 2, 2]) UnitBox();
			
		}
	}

	// Tail end detail.
	color("silver") {
		scale([1.05, 1, 1]) intersection() {
			HullShape();
			translate([0, -13900, 450]) scale([89, 5, 1]) UnitBox();
		}
		scale([1.05, 1, 1]) intersection() {
			HullShape();
			translate([0, -13900, -450]) scale([89, 5, 1]) UnitBox();
		}
	}

	// Dorsal fin.
	color("silver")
		translate([0, 0, 1000])
			scale([0.1, 1, 1])
				cylinder(h = 1100, r1 = 2100, r2 = 800);

	// Ventral fins.
	color("silver") {
		translate([0, 8900, 0])
			rotate([0, 120, 0])
				scale([0.1, 1, 1])
					cylinder(h = 3400, r1 = 2100, r2 = 800);
		translate([0, 8900, 0])
			rotate([0, -120, 0])
				scale([0.1, 1, 1])
					cylinder(h = 3400, r1 = 2100, r2 = 800);

		translate([0, -8900, 0])
			rotate([0, 120, 0])
				scale([0.1, 1, 1])
					cylinder(h = 2750, r1 = 1300, r2 = 500);
		translate([0, -8900, 0])
			rotate([0, -120, 0])
				scale([0.1, 1, 1])
					cylinder(h = 2750, r1 = 1300, r2 = 500);
	}

	// Tail fins.
	color("silver") {
		translate([0, -17500, 0]) difference() {
			rotate([30, 0, 0])
				scale([0.1, 1, 1])
					cylinder(h = 1700, r1 = 800, r2 = 200);
			translate([0, -400, -400]) scale(8) UnitBox();
		}

		translate([0, -17500, 0])
			rotate([-30, 0, 0])
				scale([0.1, 1, 1])
					mirror([0, 0, 1])
						cylinder(h = 800, r1 = 800, r2 = 200);
	}

	color("silver") {
		translate([0, 16100, 600]) GunTurret();
		translate([0, 8900, 950]) GunTurret();
		translate([0, -8900, 950])
			rotate([0, 0, 180])
				GunTurret();
		translate([0, 8900, -950])
			rotate([0, 180, 0])
				GunTurret();
		translate([0, -8900, -950])
			rotate([0, 180, 180])
				GunTurret();
	}
}

Bonaventure();
//GunTurret();

